# Create Creatives

> Source: https://truto.one/docs/api-reference/unified-ads-management-api/creatives/create/

`POST /unified/ads/creatives`

Resource: **Creatives** · API: **Unified Ads Management API**

## Supported integrations

Meta Marketing API

## Query parameters

- **`integrated_account_id`** _(string, required)_
  The ID of the integrated account to use for the request.
- **`truto_response_format`** _(string)_
  The format of the response. - `unified` returns the response with unified mappings applied. - `raw` returns the unprocessed, raw response from the remote API. - `normalized` applies the unified mappings and returns the data in a normalized format. - `stream` returns the response as a stream, which is ideal for transmitting large datasets, files, or binary data. Using streaming mode helps to efficiently handle large payloads or real-time data flows without requiring the entire data to be buffered in memory. Defaults to `unified`.
  Allowed: `unified`, `raw`, `normalized`, `stream`
- **`truto_ignore_remote_data`** _(boolean)_
  Excludes the `remote_data` attribute from the response.
- **`truto_exclude_fields`** _(array<string>)_
  Array of fields to exclude from the response.
- **`remote_query`** _(object)_
  Query parameters to pass to the underlying API without any transformations. Refer [this guide](https://truto.one/docs/api-reference/overview/querying#remote-query-parameters) to see how to structure the query parameters.

## Request body

- **`account_id`** _(string)_
  The unique identifier for the account.
- **`labels`** _(array<object>)_
  The labels for the creative.
  - **`id`** _(string)_
    The unique identifier for the label.
  - **`name`** _(string)_
    The name of the label.
- **`applink_treatment`** _(string)_
  The applink treatment for the creative.
  Allowed: `automatic`, `deeplink_with_appstore_fallback`, `deeplink_with_web_fallback`, `web_only`
- **`authorization_category`** _(string)_
  The authorization category for the creative.
  Allowed: `none`, `political`
- **`body`** _(string)_
  The body for the creative.
- **`call_to_action_type`** _(string)_
  The call to action type for the creative.
  Allowed: `open_link`, `like_page`, `shop_now`, `play_game`, `install_app`, `use_app`, `call`, `call_me`, `video_call`, `install_mobile_app`, `use_mobile_app`, `mobile_download` (+63 more)
- **`call_to_action_spec`** _(object)_
  The call to action spec for the creative.
- **`image_crops`** _(object)_
  The image crops for the creative.
- **`image_hash`** _(string)_
  The image hash for the creative.
- **`image_url`** _(string)_
  The image URL for the creative.
- **`interactive_components`** _(object)_
  The interactive components for the creative.
- **`spec`** _(object)_
  The spec for the creative.
- **`remote_data`** _(object)_
  Any additional data that should be passed as part of the request body. This data is not transformed by Truto and is passed as is to the remote API.

## Response body

- **`id`** _(string, required)_
  The unique identifier for the creative.
- **`name`** _(string)_
  The name of the creative.
- **`status`** _(string)_
  The status of the creative.
  Allowed: `active`, `deleted`, `in_process`, `with_issues`
- **`account_id`** _(string)_
  The unique identifier for the account.
- **`labels`** _(array<object>)_
  The labels for the creative.
  - **`id`** _(string)_
    The unique identifier for the label.
  - **`name`** _(string)_
    The name of the label.
- **`applink_treatment`** _(string)_
  The applink treatment for the creative.
  Allowed: `automatic`, `deeplink_with_appstore_fallback`, `deeplink_with_web_fallback`, `web_only`
- **`authorization_category`** _(string)_
  The authorization category for the creative.
  Allowed: `none`, `political`
- **`body`** _(string)_
  The body for the creative.
- **`call_to_action_type`** _(string)_
  The call to action type for the creative.
  Allowed: `open_link`, `like_page`, `shop_now`, `play_game`, `install_app`, `use_app`, `call`, `call_me`, `video_call`, `install_mobile_app`, `use_mobile_app`, `mobile_download` (+63 more)
- **`image_crops`** _(object)_
  The image crops for the creative.
- **`image_hash`** _(string)_
  The image hash for the creative.
- **`image_url`** _(string)_
  The image URL for the creative.
- **`properties`** _(array<object>)_
  The properties for the creative.
  - **`id`** _(string)_
    The unique identifier for the property.
  - **`type`** _(string)_
    The type for the property.
  - **`url`** _(string)_
    The URL for the property.
- **`spec`** _(object)_
  The spec for the creative.
- **`interactive_components`** _(object)_
  The interactive components for the creative.
- **`urls`** _(array<object>)_
  The URLs for the creative.
  - **`id`** _(string)_
    The unique identifier for the URL.
  - **`type`** _(string)_
    The type for the URL.
  - **`url`** _(string)_
    The URL for the URL.
- **`created_at`** _(string)_
  The date and time the creative was created.
- **`updated_at`** _(string)_
  The date and time the creative was last updated.
- **`remote_data`** _(object)_
  Raw data returned from the remote API call.

## Code examples

### curl

```bash
curl -X POST 'https://api.truto.one/unified/ads/creatives?integrated_account_id=<integrated_account_id>' \
  -H 'Authorization: Bearer <your_api_token>' \
  -H 'Content-Type: application/json' \
  -d '{
  "account_id": "your_account_id",
  "labels": [],
  "applink_treatment": "automatic",
  "authorization_category": "none",
  "body": "your_body",
  "call_to_action_type": "open_link",
  "call_to_action_spec": {},
  "image_crops": {},
  "image_hash": "your_image_hash",
  "image_url": "your_image_url",
  "interactive_components": {},
  "spec": {},
  "remote_data": {}
}'
```

### JavaScript

```javascript
const integratedAccountId = '<integrated_account_id>';

const body = {
  "account_id": "your_account_id",
  "labels": [],
  "applink_treatment": "automatic",
  "authorization_category": "none",
  "body": "your_body",
  "call_to_action_type": "open_link",
  "call_to_action_spec": {},
  "image_crops": {},
  "image_hash": "your_image_hash",
  "image_url": "your_image_url",
  "interactive_components": {},
  "spec": {},
  "remote_data": {}
};

const response = await fetch(`https://api.truto.one/unified/ads/creatives?integrated_account_id=${integratedAccountId}`, {
  method: 'POST',
  headers: {
    'Authorization': 'Bearer <your_api_token>',
    'Content-Type': 'application/json',
  },
  body: JSON.stringify(body),
});

const data = await response.json();
console.log(data);
```

### Python

```python
import requests

url = "https://api.truto.one/unified/ads/creatives"
headers = {
    "Authorization": "Bearer <your_api_token>",
    "Content-Type": "application/json",
}
params = {
    "integrated_account_id": "<integrated_account_id>"
}
payload = {
    "account_id": "your_account_id",
    "labels": [],
    "applink_treatment": "automatic",
    "authorization_category": "none",
    "body": "your_body",
    "call_to_action_type": "open_link",
    "call_to_action_spec": {},
    "image_crops": {},
    "image_hash": "your_image_hash",
    "image_url": "your_image_url",
    "interactive_components": {},
    "spec": {},
    "remote_data": {}
}

response = requests.post(url, headers=headers, params=params, json=payload)
print(response.json())
```

### Truto TS SDK

```typescript
import Truto from '@truto/truto-ts-sdk';

const truto = new Truto({
  token: '<your_api_token>',
});

const result = await truto.unifiedApi.create(
  'ads',
  'creatives',
  {
  "account_id": "your_account_id",
  "labels": [],
  "applink_treatment": "automatic",
  "authorization_category": "none",
  "body": "your_body",
  "call_to_action_type": "open_link",
  "call_to_action_spec": {},
  "image_crops": {},
  "image_hash": "your_image_hash",
  "image_url": "your_image_url",
  "interactive_components": {},
  "spec": {},
  "remote_data": {}
},
  { integrated_account_id: '<integrated_account_id>' }
);

console.log(result);
```

### Truto Python SDK

```python
import asyncio
from truto_python_sdk import TrutoApi

truto_api = TrutoApi(token="<your_api_token>")

async def main():
    result = await truto_api.unified_api.create(
        "ads",
        "creatives",
        {
        "account_id": "your_account_id",
        "labels": [],
        "applink_treatment": "automatic",
        "authorization_category": "none",
        "body": "your_body",
        "call_to_action_type": "open_link",
        "call_to_action_spec": {},
        "image_crops": {},
        "image_hash": "your_image_hash",
        "image_url": "your_image_url",
        "interactive_components": {},
        "spec": {},
        "remote_data": {}
},
        {"integrated_account_id": "<integrated_account_id>"}
    )
    print(result)

asyncio.run(main())
```
